# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`unbound`](#unbound): Installs and configures Unbound, the caching DNS resolver from NLnet Labs
* [`unbound::remote`](#unbound--remote): Class: unbound::remote  Configure remote control of the unbound daemon process  === Parameters:  [*enable*]   (optional) The option is used t

### Defined types

* [`unbound::forward`](#unbound--forward): Class: unbound::forward  Configures a zone for DNS forwarding  == Parameters:  [*zone*]   (required) the name of the zone.  [*address*]   IP 
* [`unbound::localzone`](#unbound--localzone): Class: unbound::localzone  Configures a local zone. The  default  zones  are  localhost, reverse 127.0.0.1 and ::1, and the AS112 zones. The 
* [`unbound::record`](#unbound--record): Class: unbound::record  Create an unbound static DNS record override  == Parameters:  [*content*]   (required) The name of the record (ip add
* [`unbound::stub`](#unbound--stub): Class: unbound::stub  Create an unbound stub zone for caching upstream name resolvers  === Parameters:  [*address*]   (required) IP address o

### Data types

* [`Unbound::Access_control`](#Unbound--Access_control)
* [`Unbound::Address`](#Unbound--Address): Patterns copied from Stdlib::IP
* [`Unbound::Chroot`](#Unbound--Chroot)
* [`Unbound::Hints_file`](#Unbound--Hints_file)
* [`Unbound::Local_zone`](#Unbound--Local_zone): custom enum type for local-zone types
* [`Unbound::Local_zone_override`](#Unbound--Local_zone_override)
* [`Unbound::Local_zone_type`](#Unbound--Local_zone_type): custom enum type for local-zone types
* [`Unbound::Module`](#Unbound--Module): list of valid modules
* [`Unbound::Range`](#Unbound--Range)
* [`Unbound::Resource_record_type`](#Unbound--Resource_record_type): custom type for resource record used for local-data
* [`Unbound::Rpz`](#Unbound--Rpz): Type used to validate rzp configueration
* [`Unbound::Rpz::Action`](#Unbound--Rpz--Action): list of valid rpz actions
* [`Unbound::Size`](#Unbound--Size)

## Classes

### <a name="unbound"></a>`unbound`

Installs and configures Unbound, the caching DNS resolver from NLnet Labs

#### Parameters

The following parameters are available in the `unbound` class:

* [`hints_file`](#-unbound--hints_file)
* [`hints_file_content`](#-unbound--hints_file_content)
* [`unbound_version`](#-unbound--unbound_version)
* [`update_root_hints`](#-unbound--update_root_hints)
* [`manage_service`](#-unbound--manage_service)
* [`verbosity`](#-unbound--verbosity)
* [`statistics_interval`](#-unbound--statistics_interval)
* [`statistics_cumulative`](#-unbound--statistics_cumulative)
* [`extended_statistics`](#-unbound--extended_statistics)
* [`num_threads`](#-unbound--num_threads)
* [`port`](#-unbound--port)
* [`interface`](#-unbound--interface)
* [`interface_automatic`](#-unbound--interface_automatic)
* [`outgoing_interface`](#-unbound--outgoing_interface)
* [`outgoing_range`](#-unbound--outgoing_range)
* [`outgoing_port_permit`](#-unbound--outgoing_port_permit)
* [`outgoing_port_avoid`](#-unbound--outgoing_port_avoid)
* [`outgoing_port_permit_first`](#-unbound--outgoing_port_permit_first)
* [`outgoing_num_tcp`](#-unbound--outgoing_num_tcp)
* [`incoming_num_tcp`](#-unbound--incoming_num_tcp)
* [`edns_buffer_size`](#-unbound--edns_buffer_size)
* [`max_udp_size`](#-unbound--max_udp_size)
* [`stream_wait_size`](#-unbound--stream_wait_size)
* [`msg_cache_size`](#-unbound--msg_cache_size)
* [`msg_cache_slabs`](#-unbound--msg_cache_slabs)
* [`num_queries_per_thread`](#-unbound--num_queries_per_thread)
* [`jostle_timeout`](#-unbound--jostle_timeout)
* [`delay_close`](#-unbound--delay_close)
* [`unknown_server_time_limit`](#-unbound--unknown_server_time_limit)
* [`so_rcvbuf`](#-unbound--so_rcvbuf)
* [`so_sndbuf`](#-unbound--so_sndbuf)
* [`so_reuseport`](#-unbound--so_reuseport)
* [`ip_transparent`](#-unbound--ip_transparent)
* [`ip_freebind`](#-unbound--ip_freebind)
* [`rrset_cache_size`](#-unbound--rrset_cache_size)
* [`rrset_cache_slabs`](#-unbound--rrset_cache_slabs)
* [`cache_max_ttl`](#-unbound--cache_max_ttl)
* [`cache_max_negative_ttl`](#-unbound--cache_max_negative_ttl)
* [`cache_min_ttl`](#-unbound--cache_min_ttl)
* [`infra_host_ttl`](#-unbound--infra_host_ttl)
* [`infra_cache_numhosts`](#-unbound--infra_cache_numhosts)
* [`infra_cache_slabs`](#-unbound--infra_cache_slabs)
* [`infra_cache_min_rtt`](#-unbound--infra_cache_min_rtt)
* [`define_tag`](#-unbound--define_tag)
* [`do_ip4`](#-unbound--do_ip4)
* [`do_ip6`](#-unbound--do_ip6)
* [`prefer_ip6`](#-unbound--prefer_ip6)
* [`do_udp`](#-unbound--do_udp)
* [`do_tcp`](#-unbound--do_tcp)
* [`tcp_mss`](#-unbound--tcp_mss)
* [`tls_cert_bundle`](#-unbound--tls_cert_bundle)
* [`tls_upstream`](#-unbound--tls_upstream)
* [`outgoing_tcp_mss`](#-unbound--outgoing_tcp_mss)
* [`tcp_idle_timeout`](#-unbound--tcp_idle_timeout)
* [`edns_tcp_keepalive`](#-unbound--edns_tcp_keepalive)
* [`edns_tcp_keepalive_timeout`](#-unbound--edns_tcp_keepalive_timeout)
* [`tcp_upstream`](#-unbound--tcp_upstream)
* [`udp_upstream_without_downstream`](#-unbound--udp_upstream_without_downstream)
* [`ssl_upstream`](#-unbound--ssl_upstream)
* [`ssl_service_key`](#-unbound--ssl_service_key)
* [`ssl_service_pem`](#-unbound--ssl_service_pem)
* [`ssl_port`](#-unbound--ssl_port)
* [`tls_ciphers`](#-unbound--tls_ciphers)
* [`tls_ciphersuites`](#-unbound--tls_ciphersuites)
* [`use_systemd`](#-unbound--use_systemd)
* [`do_daemonize`](#-unbound--do_daemonize)
* [`access_control`](#-unbound--access_control)
* [`chroot`](#-unbound--chroot)
* [`logfile`](#-unbound--logfile)
* [`log_identity`](#-unbound--log_identity)
* [`log_time_ascii`](#-unbound--log_time_ascii)
* [`log_queries`](#-unbound--log_queries)
* [`log_replies`](#-unbound--log_replies)
* [`log_tag_queryreply`](#-unbound--log_tag_queryreply)
* [`log_local_actions`](#-unbound--log_local_actions)
* [`log_servfail`](#-unbound--log_servfail)
* [`pidfile`](#-unbound--pidfile)
* [`hide_identity`](#-unbound--hide_identity)
* [`identity`](#-unbound--identity)
* [`hide_version`](#-unbound--hide_version)
* [`version`](#-unbound--version)
* [`hide_trustanchor`](#-unbound--hide_trustanchor)
* [`target_fetch_policy`](#-unbound--target_fetch_policy)
* [`harden_short_bufsize`](#-unbound--harden_short_bufsize)
* [`harden_large_queries`](#-unbound--harden_large_queries)
* [`harden_glue`](#-unbound--harden_glue)
* [`harden_dnssec_stripped`](#-unbound--harden_dnssec_stripped)
* [`harden_below_nxdomain`](#-unbound--harden_below_nxdomain)
* [`harden_referral_path`](#-unbound--harden_referral_path)
* [`harden_algo_downgrade`](#-unbound--harden_algo_downgrade)
* [`use_caps_for_id`](#-unbound--use_caps_for_id)
* [`caps_whitlist`](#-unbound--caps_whitlist)
* [`qname_minimisation`](#-unbound--qname_minimisation)
* [`qname_minimisation_strict`](#-unbound--qname_minimisation_strict)
* [`private_address`](#-unbound--private_address)
* [`private_domain`](#-unbound--private_domain)
* [`unwanted_reply_threshold`](#-unbound--unwanted_reply_threshold)
* [`do_not_query_address`](#-unbound--do_not_query_address)
* [`do_not_query_localhost`](#-unbound--do_not_query_localhost)
* [`prefetch`](#-unbound--prefetch)
* [`prefetch_key`](#-unbound--prefetch_key)
* [`deny_any`](#-unbound--deny_any)
* [`rrset_roundrobin`](#-unbound--rrset_roundrobin)
* [`minimal_responses`](#-unbound--minimal_responses)
* [`disable_dnssec_lame_check`](#-unbound--disable_dnssec_lame_check)
* [`trust_anchor_file`](#-unbound--trust_anchor_file)
* [`trust_anchor`](#-unbound--trust_anchor)
* [`trust_anchor_signaling`](#-unbound--trust_anchor_signaling)
* [`domain_insecure`](#-unbound--domain_insecure)
* [`val_sig_skew_min`](#-unbound--val_sig_skew_min)
* [`val_sig_skew_max`](#-unbound--val_sig_skew_max)
* [`val_bogus_ttl`](#-unbound--val_bogus_ttl)
* [`val_clean_additional`](#-unbound--val_clean_additional)
* [`val_log_level`](#-unbound--val_log_level)
* [`val_permissive_mode`](#-unbound--val_permissive_mode)
* [`ignore_cd_flag`](#-unbound--ignore_cd_flag)
* [`serve_expired`](#-unbound--serve_expired)
* [`serve_expired_ttl`](#-unbound--serve_expired_ttl)
* [`serve_expired_ttl_reset`](#-unbound--serve_expired_ttl_reset)
* [`serve_expired_reply_ttl`](#-unbound--serve_expired_reply_ttl)
* [`serve_expired_client_timeout`](#-unbound--serve_expired_client_timeout)
* [`val_nsec3_keysize_iterations`](#-unbound--val_nsec3_keysize_iterations)
* [`add_holddown`](#-unbound--add_holddown)
* [`del_holddown`](#-unbound--del_holddown)
* [`keep_missing`](#-unbound--keep_missing)
* [`permit_small_holddown`](#-unbound--permit_small_holddown)
* [`key_cache_size`](#-unbound--key_cache_size)
* [`key_cache_slabs`](#-unbound--key_cache_slabs)
* [`neg_cache_size`](#-unbound--neg_cache_size)
* [`unblock_lan_zones`](#-unbound--unblock_lan_zones)
* [`insecure_lan_zones`](#-unbound--insecure_lan_zones)
* [`local_zone`](#-unbound--local_zone)
* [`local_data`](#-unbound--local_data)
* [`local_data_ptr`](#-unbound--local_data_ptr)
* [`local_zone_tag`](#-unbound--local_zone_tag)
* [`local_zone_override`](#-unbound--local_zone_override)
* [`ratelimit`](#-unbound--ratelimit)
* [`ratelimit_size`](#-unbound--ratelimit_size)
* [`ratelimit_slabs`](#-unbound--ratelimit_slabs)
* [`ratelimit_factor`](#-unbound--ratelimit_factor)
* [`ratelimit_for_domain`](#-unbound--ratelimit_for_domain)
* [`ratelimit_below_domain`](#-unbound--ratelimit_below_domain)
* [`ip_ratelimit`](#-unbound--ip_ratelimit)
* [`ip_ratelimit_size`](#-unbound--ip_ratelimit_size)
* [`ip_ratelimit_slabs`](#-unbound--ip_ratelimit_slabs)
* [`ip_ratelimit_factor`](#-unbound--ip_ratelimit_factor)
* [`fast_server_permil`](#-unbound--fast_server_permil)
* [`fast_server_num`](#-unbound--fast_server_num)
* [`forward`](#-unbound--forward)
* [`stub`](#-unbound--stub)
* [`record`](#-unbound--record)
* [`access`](#-unbound--access)
* [`confdir`](#-unbound--confdir)
* [`directory`](#-unbound--directory)
* [`conf_d`](#-unbound--conf_d)
* [`config_file`](#-unbound--config_file)
* [`control_enable`](#-unbound--control_enable)
* [`control_setup_path`](#-unbound--control_setup_path)
* [`control_path`](#-unbound--control_path)
* [`fetch_client`](#-unbound--fetch_client)
* [`group`](#-unbound--group)
* [`keys_d`](#-unbound--keys_d)
* [`trusted_keys_file`](#-unbound--trusted_keys_file)
* [`module_config`](#-unbound--module_config)
* [`owner`](#-unbound--owner)
* [`username`](#-unbound--username)
* [`package_name`](#-unbound--package_name)
* [`package_ensure`](#-unbound--package_ensure)
* [`purge_unbound_conf_d`](#-unbound--purge_unbound_conf_d)
* [`root_hints_url`](#-unbound--root_hints_url)
* [`runtime_dir`](#-unbound--runtime_dir)
* [`auto_trust_anchor_file`](#-unbound--auto_trust_anchor_file)
* [`anchor_fetch_command`](#-unbound--anchor_fetch_command)
* [`service_name`](#-unbound--service_name)
* [`service_hasstatus`](#-unbound--service_hasstatus)
* [`service_ensure`](#-unbound--service_ensure)
* [`service_enable`](#-unbound--service_enable)
* [`validate_cmd`](#-unbound--validate_cmd)
* [`restart_cmd`](#-unbound--restart_cmd)
* [`custom_server_conf`](#-unbound--custom_server_conf)
* [`skip_roothints_download`](#-unbound--skip_roothints_download)
* [`python_script`](#-unbound--python_script)
* [`dns64_prefix`](#-unbound--dns64_prefix)
* [`dns64_synthall`](#-unbound--dns64_synthall)
* [`send_client_subnet`](#-unbound--send_client_subnet)
* [`client_subnet_zone`](#-unbound--client_subnet_zone)
* [`client_subnet_always_forward`](#-unbound--client_subnet_always_forward)
* [`max_client_subnet_ipv6`](#-unbound--max_client_subnet_ipv6)
* [`max_client_subnet_ipv4`](#-unbound--max_client_subnet_ipv4)
* [`min_client_subnet_ipv6`](#-unbound--min_client_subnet_ipv6)
* [`min_client_subnet_ipv4`](#-unbound--min_client_subnet_ipv4)
* [`max_ecs_tree_size_ipv4`](#-unbound--max_ecs_tree_size_ipv4)
* [`max_ecs_tree_size_ipv6`](#-unbound--max_ecs_tree_size_ipv6)
* [`ipsecmod_enabled`](#-unbound--ipsecmod_enabled)
* [`ipsecmod_hook`](#-unbound--ipsecmod_hook)
* [`ipsecmod_strict`](#-unbound--ipsecmod_strict)
* [`ipsecmod_max_ttl`](#-unbound--ipsecmod_max_ttl)
* [`ipsecmod_ignore_bogus`](#-unbound--ipsecmod_ignore_bogus)
* [`ipsecmod_whitelist`](#-unbound--ipsecmod_whitelist)
* [`backend`](#-unbound--backend)
* [`secret_seed`](#-unbound--secret_seed)
* [`redis_server_host`](#-unbound--redis_server_host)
* [`redis_server_port`](#-unbound--redis_server_port)
* [`redis_timeout`](#-unbound--redis_timeout)
* [`unbound_conf_d`](#-unbound--unbound_conf_d)
* [`rpzs`](#-unbound--rpzs)

##### <a name="-unbound--hints_file"></a>`hints_file`

Data type: `Unbound::Hints_file`

File path to the root-hints. Set to 'builtin' to remove root-hint option from unbound.conf and use built-in hints.

Default value: `"${confdir}/root.hints"`

##### <a name="-unbound--hints_file_content"></a>`hints_file_content`

Data type: `Optional[String[1]]`

Contents of the root hints file, if it's not remotely fetched.

Default value: `undef`

##### <a name="-unbound--unbound_version"></a>`unbound_version`

Data type: `Optional[String[1]]`

the version of the installed unbound instance. defaults to the fact, but you can overwrite it. this reduces the initial puppet runs from two to one

Default value: `$facts['unbound_version']`

##### <a name="-unbound--update_root_hints"></a>`update_root_hints`

Data type: `Enum['absent','present','unmanaged']`

If set to true (and hints_file isn't set to 'builtin') a systemd timer will be configured to update the root hints file every month

Default value: `fact('systemd') ? { true => 'present', default => 'unmanaged'`

##### <a name="-unbound--manage_service"></a>`manage_service`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--verbosity"></a>`verbosity`

Data type: `Integer[0,5]`



Default value: `1`

##### <a name="-unbound--statistics_interval"></a>`statistics_interval`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--statistics_cumulative"></a>`statistics_cumulative`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--extended_statistics"></a>`extended_statistics`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--num_threads"></a>`num_threads`

Data type: `Integer[1]`



Default value: `1`

##### <a name="-unbound--port"></a>`port`

Data type: `Integer[0, 65535]`



Default value: `53`

##### <a name="-unbound--interface"></a>`interface`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--interface_automatic"></a>`interface_automatic`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--outgoing_interface"></a>`outgoing_interface`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--outgoing_range"></a>`outgoing_range`

Data type: `Optional[Integer[1]]`



Default value: `undef`

##### <a name="-unbound--outgoing_port_permit"></a>`outgoing_port_permit`

Data type: `Unbound::Range`



Default value: `'32768-65535'`

##### <a name="-unbound--outgoing_port_avoid"></a>`outgoing_port_avoid`

Data type: `Unbound::Range`



Default value: `'0-32767'`

##### <a name="-unbound--outgoing_port_permit_first"></a>`outgoing_port_permit_first`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--outgoing_num_tcp"></a>`outgoing_num_tcp`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--incoming_num_tcp"></a>`incoming_num_tcp`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--edns_buffer_size"></a>`edns_buffer_size`

Data type: `Integer[0,4096]`



Default value: `1232`

##### <a name="-unbound--max_udp_size"></a>`max_udp_size`

Data type: `Optional[Integer[0,65536]]`



Default value: `undef`

##### <a name="-unbound--stream_wait_size"></a>`stream_wait_size`

Data type: `Optional[Unbound::Size]`



Default value: `undef`

##### <a name="-unbound--msg_cache_size"></a>`msg_cache_size`

Data type: `Optional[Unbound::Size]`



Default value: `undef`

##### <a name="-unbound--msg_cache_slabs"></a>`msg_cache_slabs`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--num_queries_per_thread"></a>`num_queries_per_thread`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--jostle_timeout"></a>`jostle_timeout`

Data type: `Optional[Integer[1]]`



Default value: `undef`

##### <a name="-unbound--delay_close"></a>`delay_close`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--unknown_server_time_limit"></a>`unknown_server_time_limit`

Data type: `Optional[Integer[1]]`



Default value: `undef`

##### <a name="-unbound--so_rcvbuf"></a>`so_rcvbuf`

Data type: `Optional[Unbound::Size]`



Default value: `undef`

##### <a name="-unbound--so_sndbuf"></a>`so_sndbuf`

Data type: `Optional[Unbound::Size]`



Default value: `undef`

##### <a name="-unbound--so_reuseport"></a>`so_reuseport`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--ip_transparent"></a>`ip_transparent`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--ip_freebind"></a>`ip_freebind`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--rrset_cache_size"></a>`rrset_cache_size`

Data type: `Optional[Unbound::Size]`



Default value: `undef`

##### <a name="-unbound--rrset_cache_slabs"></a>`rrset_cache_slabs`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--cache_max_ttl"></a>`cache_max_ttl`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--cache_max_negative_ttl"></a>`cache_max_negative_ttl`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--cache_min_ttl"></a>`cache_min_ttl`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--infra_host_ttl"></a>`infra_host_ttl`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--infra_cache_numhosts"></a>`infra_cache_numhosts`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--infra_cache_slabs"></a>`infra_cache_slabs`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--infra_cache_min_rtt"></a>`infra_cache_min_rtt`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--define_tag"></a>`define_tag`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--do_ip4"></a>`do_ip4`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--do_ip6"></a>`do_ip6`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--prefer_ip6"></a>`prefer_ip6`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--do_udp"></a>`do_udp`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--do_tcp"></a>`do_tcp`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--tcp_mss"></a>`tcp_mss`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--tls_cert_bundle"></a>`tls_cert_bundle`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-unbound--tls_upstream"></a>`tls_upstream`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--outgoing_tcp_mss"></a>`outgoing_tcp_mss`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--tcp_idle_timeout"></a>`tcp_idle_timeout`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--edns_tcp_keepalive"></a>`edns_tcp_keepalive`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--edns_tcp_keepalive_timeout"></a>`edns_tcp_keepalive_timeout`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--tcp_upstream"></a>`tcp_upstream`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--udp_upstream_without_downstream"></a>`udp_upstream_without_downstream`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--ssl_upstream"></a>`ssl_upstream`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--ssl_service_key"></a>`ssl_service_key`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-unbound--ssl_service_pem"></a>`ssl_service_pem`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-unbound--ssl_port"></a>`ssl_port`

Data type: `Optional[Integer[0,65535]]`



Default value: `undef`

##### <a name="-unbound--tls_ciphers"></a>`tls_ciphers`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-unbound--tls_ciphersuites"></a>`tls_ciphersuites`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-unbound--use_systemd"></a>`use_systemd`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--do_daemonize"></a>`do_daemonize`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--access_control"></a>`access_control`

Data type: `Hash[String[1], Unbound::Access_control]`



Default value: `{}`

##### <a name="-unbound--chroot"></a>`chroot`

Data type: `Optional[Unbound::Chroot]`



Default value: `undef`

##### <a name="-unbound--logfile"></a>`logfile`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-unbound--log_identity"></a>`log_identity`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-unbound--log_time_ascii"></a>`log_time_ascii`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--log_queries"></a>`log_queries`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--log_replies"></a>`log_replies`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--log_tag_queryreply"></a>`log_tag_queryreply`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--log_local_actions"></a>`log_local_actions`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--log_servfail"></a>`log_servfail`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--pidfile"></a>`pidfile`

Data type: `Stdlib::Absolutepath`



Default value: `'/var/run/unbound/unbound.pid'`

##### <a name="-unbound--hide_identity"></a>`hide_identity`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--identity"></a>`identity`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-unbound--hide_version"></a>`hide_version`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--version"></a>`version`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-unbound--hide_trustanchor"></a>`hide_trustanchor`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--target_fetch_policy"></a>`target_fetch_policy`

Data type: `Array[Integer]`



Default value: `[]`

##### <a name="-unbound--harden_short_bufsize"></a>`harden_short_bufsize`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--harden_large_queries"></a>`harden_large_queries`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--harden_glue"></a>`harden_glue`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--harden_dnssec_stripped"></a>`harden_dnssec_stripped`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--harden_below_nxdomain"></a>`harden_below_nxdomain`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--harden_referral_path"></a>`harden_referral_path`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--harden_algo_downgrade"></a>`harden_algo_downgrade`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--use_caps_for_id"></a>`use_caps_for_id`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--caps_whitlist"></a>`caps_whitlist`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--qname_minimisation"></a>`qname_minimisation`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--qname_minimisation_strict"></a>`qname_minimisation_strict`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--private_address"></a>`private_address`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--private_domain"></a>`private_domain`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--unwanted_reply_threshold"></a>`unwanted_reply_threshold`

Data type: `Integer[0]`



Default value: `10000000`

##### <a name="-unbound--do_not_query_address"></a>`do_not_query_address`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--do_not_query_localhost"></a>`do_not_query_localhost`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--prefetch"></a>`prefetch`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--prefetch_key"></a>`prefetch_key`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--deny_any"></a>`deny_any`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--rrset_roundrobin"></a>`rrset_roundrobin`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--minimal_responses"></a>`minimal_responses`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--disable_dnssec_lame_check"></a>`disable_dnssec_lame_check`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--trust_anchor_file"></a>`trust_anchor_file`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-unbound--trust_anchor"></a>`trust_anchor`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--trust_anchor_signaling"></a>`trust_anchor_signaling`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--domain_insecure"></a>`domain_insecure`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--val_sig_skew_min"></a>`val_sig_skew_min`

Data type: `Optional[Integer[1]]`



Default value: `undef`

##### <a name="-unbound--val_sig_skew_max"></a>`val_sig_skew_max`

Data type: `Optional[Integer[1]]`



Default value: `undef`

##### <a name="-unbound--val_bogus_ttl"></a>`val_bogus_ttl`

Data type: `Optional[Integer[1]]`



Default value: `undef`

##### <a name="-unbound--val_clean_additional"></a>`val_clean_additional`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--val_log_level"></a>`val_log_level`

Data type: `Optional[Integer[0,2]]`



Default value: `undef`

##### <a name="-unbound--val_permissive_mode"></a>`val_permissive_mode`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--ignore_cd_flag"></a>`ignore_cd_flag`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--serve_expired"></a>`serve_expired`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--serve_expired_ttl"></a>`serve_expired_ttl`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--serve_expired_ttl_reset"></a>`serve_expired_ttl_reset`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--serve_expired_reply_ttl"></a>`serve_expired_reply_ttl`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--serve_expired_client_timeout"></a>`serve_expired_client_timeout`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--val_nsec3_keysize_iterations"></a>`val_nsec3_keysize_iterations`

Data type: `Array[Integer[1]]`



Default value: `[]`

##### <a name="-unbound--add_holddown"></a>`add_holddown`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--del_holddown"></a>`del_holddown`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--keep_missing"></a>`keep_missing`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--permit_small_holddown"></a>`permit_small_holddown`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--key_cache_size"></a>`key_cache_size`

Data type: `Optional[Unbound::Size]`



Default value: `undef`

##### <a name="-unbound--key_cache_slabs"></a>`key_cache_slabs`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-unbound--neg_cache_size"></a>`neg_cache_size`

Data type: `Optional[Unbound::Size]`



Default value: `undef`

##### <a name="-unbound--unblock_lan_zones"></a>`unblock_lan_zones`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--insecure_lan_zones"></a>`insecure_lan_zones`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--local_zone"></a>`local_zone`

Data type: `Unbound::Local_zone`



Default value: `{}`

##### <a name="-unbound--local_data"></a>`local_data`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--local_data_ptr"></a>`local_data_ptr`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--local_zone_tag"></a>`local_zone_tag`

Data type: `Hash[String[1], Array[String[1]]]`



Default value: `{}`

##### <a name="-unbound--local_zone_override"></a>`local_zone_override`

Data type: `Hash[String[1], Unbound::Local_zone_override]`



Default value: `{}`

##### <a name="-unbound--ratelimit"></a>`ratelimit`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--ratelimit_size"></a>`ratelimit_size`

Data type: `Optional[Unbound::Size]`



Default value: `undef`

##### <a name="-unbound--ratelimit_slabs"></a>`ratelimit_slabs`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--ratelimit_factor"></a>`ratelimit_factor`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--ratelimit_for_domain"></a>`ratelimit_for_domain`

Data type: `Hash[String[1], Integer[0]]`



Default value: `{}`

##### <a name="-unbound--ratelimit_below_domain"></a>`ratelimit_below_domain`

Data type: `Hash[String[1], Integer[0]]`



Default value: `{}`

##### <a name="-unbound--ip_ratelimit"></a>`ip_ratelimit`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--ip_ratelimit_size"></a>`ip_ratelimit_size`

Data type: `Optional[Unbound::Size]`



Default value: `undef`

##### <a name="-unbound--ip_ratelimit_slabs"></a>`ip_ratelimit_slabs`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--ip_ratelimit_factor"></a>`ip_ratelimit_factor`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--fast_server_permil"></a>`fast_server_permil`

Data type: `Optional[Integer[0,1000]]`



Default value: `undef`

##### <a name="-unbound--fast_server_num"></a>`fast_server_num`

Data type: `Optional[Integer[1]]`



Default value: `undef`

##### <a name="-unbound--forward"></a>`forward`

Data type: `Hash`



Default value: `{}`

##### <a name="-unbound--stub"></a>`stub`

Data type: `Hash`



Default value: `{}`

##### <a name="-unbound--record"></a>`record`

Data type: `Hash`



Default value: `{}`

##### <a name="-unbound--access"></a>`access`

Data type: `Array`



Default value: `['::1', '127.0.0.1']`

##### <a name="-unbound--confdir"></a>`confdir`

Data type: `String[1]`



Default value: `'/etc/unbound'`

##### <a name="-unbound--directory"></a>`directory`

Data type: `Stdlib::Absolutepath`



Default value: `$confdir`

##### <a name="-unbound--conf_d"></a>`conf_d`

Data type: `String[1]`



Default value: `"${confdir}/conf.d"`

##### <a name="-unbound--config_file"></a>`config_file`

Data type: `String[1]`



Default value: `"${confdir}/unbound.conf"`

##### <a name="-unbound--control_enable"></a>`control_enable`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--control_setup_path"></a>`control_setup_path`

Data type: `String[1]`



Default value: `'/usr/sbin/unbound-control-setup'`

##### <a name="-unbound--control_path"></a>`control_path`

Data type: `String[1]`



Default value: `'/usr/sbin/unbound-control'`

##### <a name="-unbound--fetch_client"></a>`fetch_client`

Data type: `String[1]`



Default value: `'wget -O'`

##### <a name="-unbound--group"></a>`group`

Data type: `String[1]`



Default value: `'unbound'`

##### <a name="-unbound--keys_d"></a>`keys_d`

Data type: `String[1]`



Default value: `"${confdir}/keys.d"`

##### <a name="-unbound--trusted_keys_file"></a>`trusted_keys_file`

Data type: `Stdlib::Absolutepath`



Default value: `"${keys_d}/*.key"`

##### <a name="-unbound--module_config"></a>`module_config`

Data type: `Array[Unbound::Module]`



Default value: `[]`

##### <a name="-unbound--owner"></a>`owner`

Data type: `String[1]`



Default value: `'unbound'`

##### <a name="-unbound--username"></a>`username`

Data type: `String[1]`



Default value: `$owner`

##### <a name="-unbound--package_name"></a>`package_name`

Data type: `String`



Default value: `'unbound'`

##### <a name="-unbound--package_ensure"></a>`package_ensure`

Data type: `String[1]`



Default value: `'installed'`

##### <a name="-unbound--purge_unbound_conf_d"></a>`purge_unbound_conf_d`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--root_hints_url"></a>`root_hints_url`

Data type: `String[1]`



Default value: `'https://www.internic.net/domain/named.root'`

##### <a name="-unbound--runtime_dir"></a>`runtime_dir`

Data type: `Stdlib::Absolutepath`



Default value: `$confdir`

##### <a name="-unbound--auto_trust_anchor_file"></a>`auto_trust_anchor_file`

Data type: `Stdlib::Absolutepath`



Default value: `"${runtime_dir}/root.key"`

##### <a name="-unbound--anchor_fetch_command"></a>`anchor_fetch_command`

Data type: `String[1]`



Default value: `"unbound-anchor -a ${auto_trust_anchor_file}"`

##### <a name="-unbound--service_name"></a>`service_name`

Data type: `String[1]`



Default value: `'unbound'`

##### <a name="-unbound--service_hasstatus"></a>`service_hasstatus`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--service_ensure"></a>`service_ensure`

Data type: `Enum['running', 'stopped']`



Default value: `'running'`

##### <a name="-unbound--service_enable"></a>`service_enable`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--validate_cmd"></a>`validate_cmd`

Data type: `String[1]`



Default value: `'/usr/sbin/unbound-checkconf %'`

##### <a name="-unbound--restart_cmd"></a>`restart_cmd`

Data type: `String[1]`



Default value: `"/bin/systemctl restart ${service_name}"`

##### <a name="-unbound--custom_server_conf"></a>`custom_server_conf`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--skip_roothints_download"></a>`skip_roothints_download`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--python_script"></a>`python_script`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-unbound--dns64_prefix"></a>`dns64_prefix`

Data type: `String[1]`



Default value: `'64:ff9b::/96'`

##### <a name="-unbound--dns64_synthall"></a>`dns64_synthall`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--send_client_subnet"></a>`send_client_subnet`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--client_subnet_zone"></a>`client_subnet_zone`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--client_subnet_always_forward"></a>`client_subnet_always_forward`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--max_client_subnet_ipv6"></a>`max_client_subnet_ipv6`

Data type: `Integer[0,128]`



Default value: `56`

##### <a name="-unbound--max_client_subnet_ipv4"></a>`max_client_subnet_ipv4`

Data type: `Integer[0,32]`



Default value: `24`

##### <a name="-unbound--min_client_subnet_ipv6"></a>`min_client_subnet_ipv6`

Data type: `Optional[Integer[0,128]]`



Default value: `undef`

##### <a name="-unbound--min_client_subnet_ipv4"></a>`min_client_subnet_ipv4`

Data type: `Optional[Integer[0,32]]`



Default value: `undef`

##### <a name="-unbound--max_ecs_tree_size_ipv4"></a>`max_ecs_tree_size_ipv4`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--max_ecs_tree_size_ipv6"></a>`max_ecs_tree_size_ipv6`

Data type: `Optional[Integer[0]]`



Default value: `undef`

##### <a name="-unbound--ipsecmod_enabled"></a>`ipsecmod_enabled`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--ipsecmod_hook"></a>`ipsecmod_hook`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `undef`

##### <a name="-unbound--ipsecmod_strict"></a>`ipsecmod_strict`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--ipsecmod_max_ttl"></a>`ipsecmod_max_ttl`

Data type: `Integer[1]`



Default value: `3600`

##### <a name="-unbound--ipsecmod_ignore_bogus"></a>`ipsecmod_ignore_bogus`

Data type: `Boolean`



Default value: `false`

##### <a name="-unbound--ipsecmod_whitelist"></a>`ipsecmod_whitelist`

Data type: `Array[String[1]]`



Default value: `[]`

##### <a name="-unbound--backend"></a>`backend`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-unbound--secret_seed"></a>`secret_seed`

Data type: `String[1]`



Default value: `'default'`

##### <a name="-unbound--redis_server_host"></a>`redis_server_host`

Data type: `String[1]`



Default value: `'127.0.0.1'`

##### <a name="-unbound--redis_server_port"></a>`redis_server_port`

Data type: `Integer[1,65536]`



Default value: `6379`

##### <a name="-unbound--redis_timeout"></a>`redis_timeout`

Data type: `Integer[1]`



Default value: `100`

##### <a name="-unbound--unbound_conf_d"></a>`unbound_conf_d`

Data type: `Stdlib::Absolutepath`



Default value: `"${confdir}/unbound.conf.d"`

##### <a name="-unbound--rpzs"></a>`rpzs`

Data type: `Hash[String[1], Unbound::Rpz]`



Default value: `{}`

### <a name="unbound--remote"></a>`unbound::remote`

Class: unbound::remote

Configure remote control of the unbound daemon process

=== Parameters:

[*enable*]
  (optional) The option is used to enable remote control, default is false.
  If turned off, the server does not listen for  control.

[*interface*]
  (optional) Give  IPv4  or IPv6 addresses to listen on for control commands.
  By default localhost (127.0.0.1 and ::1) is listened.

[*port*]
  (optional) The port number to listen on for control commands, default is
  8953.  If you change this port number,  and  permissions have been dropped,
  a reload is not sufficient to open the port again, you must then restart.

[*server_key_file*]
  (optional) Path to the server private key, by default unbound_server.key.
  This file is generated by the unbound-control-setup utility.  This file is
  used by the unbound server, but not by unbound-control.

[*server_cert_file*]
  (optional) Path to the server self signed certificate, by default
  unbound_server.pem.  This file is generated by the unbound-control-setup
  utility.  This file is used by the unbound server, and also by
  unbound-control.

[*control_key_file*]
  (optional) Path to the control client private key, by default
  unbound_control.key.  This file is generated by the unbound-control-setup
  utility.  This file is used by unbound-control.

[*control_cert_file*]
  (optional) Path to the control client certificate, by default
  unbound_control.pem.  This certificate has to be  signed  with  the server
  certificate. This file is generated by the unbound-control-setup utility.
  This file is used by unbound-control.

[*group*]
  (optional) Name of the group for unbound files and directory

[*confdir*]
  (optional) Name of the directory where configuration files are stored

[*config_file*]
  (optional) Name of the unbound config file

#### Parameters

The following parameters are available in the `unbound::remote` class:

* [`enable`](#-unbound--remote--enable)
* [`interface`](#-unbound--remote--interface)
* [`port`](#-unbound--remote--port)
* [`control_use_cert`](#-unbound--remote--control_use_cert)
* [`server_key_file`](#-unbound--remote--server_key_file)
* [`server_cert_file`](#-unbound--remote--server_cert_file)
* [`control_key_file`](#-unbound--remote--control_key_file)
* [`control_cert_file`](#-unbound--remote--control_cert_file)
* [`group`](#-unbound--remote--group)
* [`confdir`](#-unbound--remote--confdir)
* [`config_file`](#-unbound--remote--config_file)
* [`control_setup_path`](#-unbound--remote--control_setup_path)

##### <a name="-unbound--remote--enable"></a>`enable`

Data type: `Boolean`



Default value: `$unbound::control_enable`

##### <a name="-unbound--remote--interface"></a>`interface`

Data type: `Array`



Default value: `['::1', '127.0.0.1']`

##### <a name="-unbound--remote--port"></a>`port`

Data type: `Integer`



Default value: `8953`

##### <a name="-unbound--remote--control_use_cert"></a>`control_use_cert`

Data type: `Boolean`



Default value: `true`

##### <a name="-unbound--remote--server_key_file"></a>`server_key_file`

Data type: `String`



Default value: `"${unbound::confdir}/unbound_server.key"`

##### <a name="-unbound--remote--server_cert_file"></a>`server_cert_file`

Data type: `String`



Default value: `"${unbound::confdir}/unbound_server.pem"`

##### <a name="-unbound--remote--control_key_file"></a>`control_key_file`

Data type: `String`



Default value: `"${$unbound::confdir}/unbound_control.key"`

##### <a name="-unbound--remote--control_cert_file"></a>`control_cert_file`

Data type: `String`



Default value: `"${$unbound::confdir}/unbound_control.pem"`

##### <a name="-unbound--remote--group"></a>`group`

Data type: `Any`



Default value: `$unbound::group`

##### <a name="-unbound--remote--confdir"></a>`confdir`

Data type: `Any`



Default value: `$unbound::confdir`

##### <a name="-unbound--remote--config_file"></a>`config_file`

Data type: `Any`



Default value: `$unbound::config_file`

##### <a name="-unbound--remote--control_setup_path"></a>`control_setup_path`

Data type: `Any`



Default value: `$unbound::control_setup_path`

## Defined types

### <a name="unbound--forward"></a>`unbound::forward`

Class: unbound::forward

Configures a zone for DNS forwarding

== Parameters:

[*zone*]
  (required) the name of the zone.

[*address*]
  IP address of server to forward queries to. Can be IP 4 or IP 6 (and an
  array or a single value. To use a nondefault port for DNS communication
  append '@' with the port number.

[*host*]
  Hostname of server to forward queries to. Can be IP 4 or IP 6 (and an array
  or a single value. To use a nondefault port for DNS communication append
  '@' with the port number.

[*forward_first*]
  (optional) If enabled, a query is attempted without the forward clause if
  it fails.  The data could not be retrieved and would have caused SERVFAIL
  because the servers are unreachable, instead it is tried without this
  clause. The default is 'no'.

[*forward_ssl_upstream*]
  (optional) If enabled, unbound will query the forward DNS server via TLS.

[*config_file*]
  (optional) name of configuration file

#### Parameters

The following parameters are available in the `unbound::forward` defined type:

* [`address`](#-unbound--forward--address)
* [`host`](#-unbound--forward--host)
* [`zone`](#-unbound--forward--zone)
* [`forward_first`](#-unbound--forward--forward_first)
* [`forward_ssl_upstream`](#-unbound--forward--forward_ssl_upstream)
* [`forward_tls_upstream`](#-unbound--forward--forward_tls_upstream)
* [`config_file`](#-unbound--forward--config_file)

##### <a name="-unbound--forward--address"></a>`address`

Data type: `Array`



Default value: `[]`

##### <a name="-unbound--forward--host"></a>`host`

Data type: `Array`



Default value: `[]`

##### <a name="-unbound--forward--zone"></a>`zone`

Data type: `Any`



Default value: `$name`

##### <a name="-unbound--forward--forward_first"></a>`forward_first`

Data type: `Pattern[/yes|no/]`



Default value: `'no'`

##### <a name="-unbound--forward--forward_ssl_upstream"></a>`forward_ssl_upstream`

Data type: `Pattern[/yes|no/]`



Default value: `'no'`

##### <a name="-unbound--forward--forward_tls_upstream"></a>`forward_tls_upstream`

Data type: `Pattern[/yes|no/]`



Default value: `'no'`

##### <a name="-unbound--forward--config_file"></a>`config_file`

Data type: `Any`



Default value: `$unbound::config_file`

### <a name="unbound--localzone"></a>`unbound::localzone`

Class: unbound::localzone

Configures a local zone.
The  default  zones  are  localhost, reverse 127.0.0.1 and ::1, and the
AS112 zones. The AS112 zones are reverse DNS zones for private use  and
reserved IP addresses for which the servers on the internet cannot pro-
vide correct answers.

=== Parameters:

[*zone*]
  (required) String. Zone name.

[*type*]
  (required) Custom type Unbound::Local_zone_type.

[*config_file*]
  (optional) name of configuration file.

[*local_data*]
  (optional) Array.
  Define local data which should be rendered into configuration file. Required
  value is an Array of the custom type Unbond::Resource_record_type.
  Default value: [].
  Example:
    unbound::localzone::local_data:
      - name: 'api.test.com'
        ttl: 15
        class: IN
        type: A
        data: '1.1.1.1'
      - name: 'backend.test.com'
        type: A
        data: '2.2.2.2'

[*template_name*]
  (optional) String.
  Use a custom template.
  Default value: 'unbound/local_zone.erb'.

#### Parameters

The following parameters are available in the `unbound::localzone` defined type:

* [`type`](#-unbound--localzone--type)
* [`zone`](#-unbound--localzone--zone)
* [`config_file`](#-unbound--localzone--config_file)
* [`local_data`](#-unbound--localzone--local_data)
* [`template_name`](#-unbound--localzone--template_name)

##### <a name="-unbound--localzone--type"></a>`type`

Data type: `Unbound::Local_zone_type`



##### <a name="-unbound--localzone--zone"></a>`zone`

Data type: `String`



Default value: `$name`

##### <a name="-unbound--localzone--config_file"></a>`config_file`

Data type: `Any`



Default value: `$unbound::config_file`

##### <a name="-unbound--localzone--local_data"></a>`local_data`

Data type: `Array[Unbound::Resource_record_type]`



Default value: `[]`

##### <a name="-unbound--localzone--template_name"></a>`template_name`

Data type: `String`



Default value: `'unbound/local_zone.erb'`

### <a name="unbound--record"></a>`unbound::record`

Class: unbound::record

Create an unbound static DNS record override

== Parameters:

[*content*]
  (required) The name of the record (ip address)

[*ttl*]
  (optional) The time to live for this record, defaults to '14400'

[*type*]
  (optional) Type or the record

[*reverse*]
  (optional) Reverse record or not, defaults to false

[*entry*]
  (optional) Name entry for the record (name)

[*config_file*]
  (optional) name of configuration file

#### Parameters

The following parameters are available in the `unbound::record` defined type:

* [`content`](#-unbound--record--content)
* [`ttl`](#-unbound--record--ttl)
* [`type`](#-unbound--record--type)
* [`reverse`](#-unbound--record--reverse)
* [`entry`](#-unbound--record--entry)
* [`config_file`](#-unbound--record--config_file)

##### <a name="-unbound--record--content"></a>`content`

Data type: `Variant[Array[String[1]], String[1]]`



##### <a name="-unbound--record--ttl"></a>`ttl`

Data type: `Any`



Default value: `'14400'`

##### <a name="-unbound--record--type"></a>`type`

Data type: `Any`



Default value: `'A'`

##### <a name="-unbound--record--reverse"></a>`reverse`

Data type: `Any`



Default value: `false`

##### <a name="-unbound--record--entry"></a>`entry`

Data type: `Any`



Default value: `$name`

##### <a name="-unbound--record--config_file"></a>`config_file`

Data type: `Any`



Default value: `$unbound::config_file`

### <a name="unbound--stub"></a>`unbound::stub`

Class: unbound::stub

Create an unbound stub zone for caching upstream name resolvers

=== Parameters:

[*address*]
  (required) IP address of server to forward to. Can be IP 4 or IP 6 (and an
  array or a single value. To use a nondefault port for DNS communication
  append  '@' with the port number.

[*nameservers*]
  (optional) Name of stub zone nameserver. Is itself resolved before it is used.

[*insecure*]
  (optional) Defaults to false. Sets domain name to be insecure, DNSSEC chain
  of trust is ignored towards the domain name.  So a trust anchor  above the
  domain  name can not make the domain secure with a DS record, such a DS
  record is then ignored.  Also keys from DLV are ignored for the domain.
  Can be given multiple times to specify multiple domains  that  are  treated
  as  if unsigned.  If you set trust anchors for the domain they override
  this setting (and the domain is secured).
  This can be useful if you want to make sure a trust anchor for external
  lookups does not affect an (unsigned) internal domain.  A DS record
  externally can create validation failures for that internal domain.

[*stub_first*]
  (optional) Defaults to false. Controls 'stub-first' stub zone option.
  If true, a query that fails with the stub clause is attempted again
  without the stub clause.

[*type*]
  (optional) Defaults to 'transparent', can be 'deny', 'refuse', 'static',
  'transparent', 'typetransparent', 'redirect' or 'nodefault'.

[*config_file*]
  (optional) Name of the unbound config file

#### Parameters

The following parameters are available in the `unbound::stub` defined type:

* [`address`](#-unbound--stub--address)
* [`nameservers`](#-unbound--stub--nameservers)
* [`insecure`](#-unbound--stub--insecure)
* [`no_cache`](#-unbound--stub--no_cache)
* [`stub_first`](#-unbound--stub--stub_first)
* [`type`](#-unbound--stub--type)
* [`config_file`](#-unbound--stub--config_file)

##### <a name="-unbound--stub--address"></a>`address`

Data type: `Variant[Array[Unbound::Address], Unbound::Address]`



##### <a name="-unbound--stub--nameservers"></a>`nameservers`

Data type: `Array[Stdlib::Host]`



Default value: `[]`

##### <a name="-unbound--stub--insecure"></a>`insecure`

Data type: `Variant[Boolean, Enum['true', 'false']]`



Default value: `false`

##### <a name="-unbound--stub--no_cache"></a>`no_cache`

Data type: `Variant[Boolean, Enum['true', 'false']]`



Default value: `false`

##### <a name="-unbound--stub--stub_first"></a>`stub_first`

Data type: `Variant[Boolean, Enum['true', 'false']]`



Default value: `false`

##### <a name="-unbound--stub--type"></a>`type`

Data type: `Unbound::Local_zone_type`



Default value: `'transparent'`

##### <a name="-unbound--stub--config_file"></a>`config_file`

Data type: `Optional[Stdlib::Unixpath]`



Default value: `undef`

## Data types

### <a name="Unbound--Access_control"></a>`Unbound::Access_control`

The Unbound::Access_control data type.

Alias of

```puppet
Struct[{
    action    => Optional[Enum['deny', 'refuse', 'allow', 'allow_snoop', 'deny_non_local', 'refuse_non_local']],
    tags      => Optional[Array[String]],
    rr_string => Optional[String],
    view      => Optional[String],
}]
```

### <a name="Unbound--Address"></a>`Unbound::Address`

Patterns copied from Stdlib::IP

Alias of

```puppet
Variant[Stdlib::IP::Address::Nosubnet, Pattern[
    /\A([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}@\d{1,5}\z/,
    /\A[[:xdigit:]]{1,4}(:[[:xdigit:]]{1,4}){7}(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){6}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){5}:([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){4}(:[[:xdigit:]]{1,4}){0,1}:([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){3}(:[[:xdigit:]]{1,4}){0,2}:([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){2}(:[[:xdigit:]]{1,4}){0,3}:([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){1}(:[[:xdigit:]]{1,4}){0,4}:([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A:(:[[:xdigit:]]{1,4}){0,5}:([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\.([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])){3}(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A:(:|(:[[:xdigit:]]{1,4}){1,7})(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){1}(:|(:[[:xdigit:]]{1,4}){1,6})(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){2}(:|(:[[:xdigit:]]{1,4}){1,5})(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){3}(:|(:[[:xdigit:]]{1,4}){1,4})(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){4}(:|(:[[:xdigit:]]{1,4}){1,3})(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){5}(:|(:[[:xdigit:]]{1,4}){1,2})(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){6}(:|(:[[:xdigit:]]{1,4}){1,1})(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
    /\A([[:xdigit:]]{1,4}:){7}:(\/(1([01][0-9]|2[0-8])|[1-9][0-9]|[0-9]))?@\d{1,5}\z/,
  ]]
```

### <a name="Unbound--Chroot"></a>`Unbound::Chroot`

The Unbound::Chroot data type.

Alias of `Variant[Enum[''], Stdlib::Absolutepath]`

### <a name="Unbound--Hints_file"></a>`Unbound::Hints_file`

The Unbound::Hints_file data type.

Alias of `Variant[Enum['builtin'], Stdlib::Absolutepath]`

### <a name="Unbound--Local_zone"></a>`Unbound::Local_zone`

custom enum type for local-zone types

Alias of `Hash[String, Unbound::Local_zone_type]`

### <a name="Unbound--Local_zone_override"></a>`Unbound::Local_zone_override`

The Unbound::Local_zone_override data type.

Alias of

```puppet
Struct[{
    netblock => String,
    type     => Unbound::Local_zone_type
}]
```

### <a name="Unbound--Local_zone_type"></a>`Unbound::Local_zone_type`

custom enum type for local-zone types

Alias of `Enum['deny', 'refuse', 'static', 'transparent', 'redirect', 'nodefault', 'typetransparent', 'inform', 'inform_deny', 'always_transparent', 'always_refuse', 'always_nxdomain']`

### <a name="Unbound--Module"></a>`Unbound::Module`

list of valid modules

Alias of `Enum['validator', 'iterator', 'python', 'dns64', 'subnetcache', 'ipsecmod', 'cachedb', 'respip']`

### <a name="Unbound--Range"></a>`Unbound::Range`

The Unbound::Range data type.

Alias of `Pattern[/\d+(-\d+)?/]`

### <a name="Unbound--Resource_record_type"></a>`Unbound::Resource_record_type`

custom type for resource record used for local-data

Alias of

```puppet
Struct[{
    'name'      => String,
    'ttl'       => Optional[Integer],
    'class'     => Optional[String],
    'type'      => String,
    'data'      => String,
}]
```

### <a name="Unbound--Rpz"></a>`Unbound::Rpz`

Type used to validate rzp configueration

Alias of

```puppet
Struct[{
    primary             => Optional[Array[Stdlib::Host]],
    master              => Optional[Array[Stdlib::Host]],
    url                 => Optional[Array[Stdlib::HTTPUrl]],
    allow_notify        => Optional[Array[Stdlib::Host]],
    zonefile            => Optional[Stdlib::Unixpath],
    rpz_action_override => Optional[Unbound::Rpz::Action],
    rpz_cname_override  => Optional[Stdlib::Fqdn],
    rpz_log             => Optional[Boolean],
    rpz_log_name        => Optional[String],
    tags                => Optional[Array[String]],
}]
```

#### Parameters

The following parameters are available in the `Unbound::Rpz` data type:

* [`primary`](#-Unbound--Rpz--primary)
* [`master`](#-Unbound--Rpz--master)
* [`url`](#-Unbound--Rpz--url)
* [`allow_notify`](#-Unbound--Rpz--allow_notify)
* [`zonefile`](#-Unbound--Rpz--zonefile)
* [`rpz_action_override`](#-Unbound--Rpz--rpz_action_override)
* [`rpz_cname_override`](#-Unbound--Rpz--rpz_cname_override)
* [`rpz_log`](#-Unbound--Rpz--rpz_log)
* [`rpz_log_name`](#-Unbound--Rpz--rpz_log_name)
* [`tags`](#-Unbound--Rpz--tags)

##### <a name="-Unbound--Rpz--primary"></a>`primary`

the primary name server

##### <a name="-Unbound--Rpz--master"></a>`master`

another name for the primary name server

##### <a name="-Unbound--Rpz--url"></a>`url`

to download the rpz zone

##### <a name="-Unbound--Rpz--allow_notify"></a>`allow_notify`

list of hosts allowed to notify

##### <a name="-Unbound--Rpz--zonefile"></a>`zonefile`

path to zonefile

##### <a name="-Unbound--Rpz--rpz_action_override"></a>`rpz_action_override`

Always use this RPZ action for matching triggers
from this zone. Possible action are: nxdomain, nodata, passthru, drop,
disabled and cname.

##### <a name="-Unbound--Rpz--rpz_cname_override"></a>`rpz_cname_override`

The CNAME target domain to use if the cname action
is configured for rpz-action-override.

##### <a name="-Unbound--Rpz--rpz_log"></a>`rpz_log`

Log all applied RPZ actions for this RPZ zone

##### <a name="-Unbound--Rpz--rpz_log_name"></a>`rpz_log_name`

Specify a string to be part of the log line, for easy referencing.

##### <a name="-Unbound--Rpz--tags"></a>`tags`

Limit the policies from this RPZ clause to clients with a matching tag

### <a name="Unbound--Rpz--Action"></a>`Unbound::Rpz::Action`

list of valid rpz actions

Alias of `Enum['nxdomain', 'nodata', 'passthru', 'drop', 'disabled', 'cname']`

### <a name="Unbound--Size"></a>`Unbound::Size`

The Unbound::Size data type.

Alias of `Pattern[/\d+([kmg])?/]`

